function P=sobolpts(n0,nPts,d,pVec, mMat)
    nMax=n0+nPts-1;
    rMax=1+floor(log(nMax)/log(2));
    r=1;
    P=zeros(nPts,d);
    y=zeros(rMax,d);
    V=cell(d,rmax,rmax);
    if n0>1 
        r=1+floor(log(n0-1)/log(2)); 
    end;
    qnext=2^r;
    a=bary(n0-1,2);
    g=graycode(n0-1);
    for i=1:d
        q=floor(log(pvec(i))/log(2));
        cvec=bary(pvec(i),2);
        V(i)=sobolmat([1 cvec 1],mMat(i,1:q),rMax);
    end;
    bpwrs=.5^(1:rmax);
    for i=1:d
        for m=1:r
            for n=1:r
                y(m,i)=V(i,m,n)*mod(g(r-n+1),2);
            end;
        end;
    end;
    
    
function g=graycode(n)
        a=bary(n,2);
        b=bary(floor(n/2),2);
        l=length(a);
        g=zeros(1,l);
        for i=1:l
            g(i)=bitxor(a(i),b(i));
        end;
            