%%
figure(1); clf;
Tgasoline=round((gasoline(end,2:end)-300)./22);
Error=fGasolineError;
hold on;
a=plot(Tgasoline,fGasolineError(2,:)*100,'o',...
    'MarkerEdgeColor','k');
b=plot(Tgasoline,Error(3,:)*100,'*','MarkerEdgeColor','k');
c=plot(Tgasoline,Error(4,:)*100,'^','MarkerEdgeColor','k');
d=plot(Tgasoline,Error(5,:)*100,'p','MarkerEdgeColor','k');

ylabel('Error %');
xlabel('Time to Maturity (Months)');
legend([a,b,c,d],'OF','OFS','TF','TFS');
%%
figure(2); clf;
Tnatgas=round((HBnatgas(end,2:end)-300)./22);
Error=fNatGasError;
hold on;
a=plot(Tnatgas,Error(2,:)*100,'o',...
    'MarkerEdgeColor','k');
b=plot(Tnatgas,Error(3,:)*100,'*','MarkerEdgeColor','k');
c=plot(Tnatgas,Error(4,:)*100,'^','MarkerEdgeColor','k');
d=plot(Tnatgas,Error(5,:)*100,'p','MarkerEdgeColor','k');
ylabel('Error %');
xlabel('Time to Maturity (Months)');
legend([a,b,c,d],'OF','OFS','TF','TFS');
%%
figure(3); clf;
Tlightoil=round((lightoil(end,2:end)-300)./22);
Error=fLightOilError;
hold on;
a=plot(Tlightoil,Error(2,:)*100,'o',...
    'MarkerEdgeColor','k');
b=plot(Tlightoil,Error(3,:)*100,'*','MarkerEdgeColor','k');
c=plot(Tlightoil,Error(4,:)*100,'^','MarkerEdgeColor','k');
d=plot(Tlightoil,Error(5,:)*100,'p','MarkerEdgeColor','k');
ylabel('Error %');
xlabel('Time to Maturity (Months)');
legend([a,b,c,d],'OF','OFS','TF','TFS');