function F=OUfutprice2F(~,t,T,vec,vecSeas,xt,risk,B)
% x0=vec(1);
% z0=vec(2);
k=vec(3);
m=vec(4);
sigma1=vec(5);
sigma2=vec(6);
rho=sin(vec(7));
lj=vec(8);
sj=vec(9);
%% Seasonality Parameters
alpha=vecSeas(1);
zeta=vecSeas(2);
phi=vecSeas(3);
psi=vecSeas(4);
tau=T;
%% Market Risk values
h1=risk(1);
h2=risk(2);
if length(risk)>2
    beta=risk(3);
else beta=0;
end;
%% Exponentials of tau kappa
exp1k=exp(-k*tau);
exp2k=exp(-2*k*tau);
%% Seasonality
S=alpha+zeta*sin(psi*(T+t)+phi);
%%Calculate Jump-Risk
R=excrisk(h1,sigma1,beta,sj,lj*tau);
%%
A=(m+h2)*tau+R/k.*(1-exp1k)+sigma1^2*.25/k*(1-exp2k)+(rho*sigma1*sigma2)/k*(1-exp1k)+.5*sigma2^2*tau;

if length(xt)<2
    St=exp1k*xt(1);
else
    St=exp1k*xt(1)+xt(2);
end;
%%
F=S+St+A+B';
