function X=OUgenerator2F(vec,xt,delta,N)
%vec([3,5,6,8,9])=abs(vec([3,5,6,8,9]));
% x0=vec(1);
% z0=vec(2);
persistent sR;
persistent cR;
if isempty(sR)
    cR=1;
    sR=sobolset(2,'Skip',1e4,'Leap',1e2);
    sR = scramble(sR,'MatousekAffineOwen');
end;

k=vec(3);
m=vec(4);
sigma1=vec(5);
sigma2=vec(6);
rho=vec(7);
lj=vec(8);
sj=vec(9);
exp1k=exp(-k*delta);
exp2k=exp(-2*k*delta);
%r1=randn([N,2]);
r1=sR(cR:N+cR-1,:);
cR=cR+N;
r1=norminv(r1,0,1);
D=[exp1k 0; 0 1];
g=[0;m*delta];
RR=[sigma1^2*.25/k*(1-exp2k) (rho*sigma1*sigma2)/k*(1-exp1k);...
    (rho*sigma1*sigma2)/k*(1-exp1k) .5*sigma2^2*delta];
R=real(sqrtm(RR));

if lj~=0
    J=random('poiss',lj,[N,1]);

    if max(J)~=0
        r2=((sj*randn([N,max(J)])));
    else r2=0;
    end;

    Jump=[(sum(r2,2).*(J>0))';zeros(1,N)];
else
    Jump=0;
end;
MU=D*xt'+g;
VAR=R*r1'+Jump;
X(1,:)=MU(1)+VAR(1,:);%+r3;
X(2,:)=MU(2)+VAR(2,:);