clear;
clc;
clear;
D=xlsread('OptionPricesNEW_still.xlsx','FTSE100','B5:H104');
S=xlsread('OptionPricesNEW_still.xlsx','FTSE100','C3');
rf=rffix(D,S);
%%
delta=1/252;
[n,m]=size(D);
%index=(rand(n,1)<.25);
index=[true;true;true;false;true;false;false;false;false;false;false;false;true;false;false;true;false;false;false;true;false;false;true;false;false;false;true;false;true;false;false;false;false;false;true;false;true;false;false;false;true;false;true;false;true;true;false;false;true;false;false;true;false;false;true;false;false;false;false;false;false;true;false;false;false;false;false;true;false;false;false;false;false;false;false;true;false;false;false;true;false;true;false;false;false;true;false;false;false;false;false;false;false;false;true;false;false;false;false;false;];
%index=ones(1,n)*true;
inFTSE100=D(~index,:);
outFTSE100=D(index,:);
K=inFTSE100(:,1);
T=inFTSE100(:,3)*delta;
bid=inFTSE100(:,5);
ask=inFTSE100(:,4);
C=(bid+ask)./2;
r=rf(~index);
options=optimset('MaxFunEvals',30000,'MaxIter',30000);
w= 1./abs(bid-ask).^2;
x0=[1;0.387773349226677;0.0701296152507458;-0.160522541539355;-3.44464311038336;];
%x0=randn([5 1]).*[4 1 1 1 1 ]';
 eps=0.00000000000000000000000000001;
 i=0;
 fval1=10000;k=1;
outK=outFTSE100(:,1);
outT=outFTSE100(:,3)*delta;
outbid=outFTSE100(:,5);
outask=outFTSE100(:,4);
outC=(outbid+outask)./2;
outr=rf(index);
tic;
 while k>eps
 [Theta, fval]=fminsearch(@(c) minfunc(c,C,K,T,S,r,w),x0,options);
 k=abs(fval-fval1);
 fval1=fval; 
 i=i+1;
 end;
 toc;
MRAE=mean(abs(C-mmpricer(Theta,K,T,S,r))./C)*100;
maxERRORin=max(abs(C-mmpricer(Theta,K,T,S,r))./C)*100;
RMSEin=sqrt(sum((C-mmpricer(Theta,K,T,S,r)).^2)./length(C));

display('------------In-Sample--------------');
display(['Function Value  ',num2str(fval)]);
display(['Fitting Error (MRAE %) = ',num2str(MRAE),' %']);
display(['Fitting Error (RMSE) = ',num2str(RMSEin)]);
display(['Maximum Error = ',num2str(maxERRORin)]);
g=length(outK);
outCn=zeros(1,g);
for i=1:g
    outCn(i)=mmpricer(Theta,outK(i),outT(i),S,outr(i));
end;

MRAEout=mean(abs(outC-outCn')./outC)*100;
maxERRORout=max(abs(outC-outCn')./outC)*100;
MSE=sum((outC-outCn').^2)/length(outC);
RMSE=sqrt(MSE);
display('-----------Out-Of-Sample------------');
display(['Out of Sample Error (MRAE %) = ',num2str(MRAEout),' %']);
display(['Out of Sample Error (RMSE) = ',num2str(RMSE)])
display(['Out-Of-Sample Maximum Error = ',num2str(maxERRORout)]);
%plot(abs(outC-outCn')./outC);
 inmoney_outmoney(D,S,Theta,rf,delta,7,'FTSE');