clear;
clc;
load DAXnew.mat
[n,m]=size(DAXnew);
%index=(rand(n,1)<.25);
index=[false;true;false;true;false;false;false;false;true;true;true;false;false;false;false;true;false;true;false;false;false;true;false;false;false;false;true;false;true;false;false;false;false;false;false;true;false;false;false;false;true;false;false;false;false;false;true;false;false;true;false;false;true;false;false;true;true;false;true;false;false;false;true;false;false;true;false;false;true;false;true;false;false;false;false;false;false;false;false;false;true;false;true;true;false;true;false;false;true;false;true;false;false;false;false;false;false;false;false;false;false;false;false;false;false;false;false;false;false;true;false;true;false;false;false;true;false;false;false;false];
inSANDP500=DAXnew(~index,:);
outSANDP500=DAXnew(index,:);
K=inSANDP500(:,1);
T=inSANDP500(:,4);
bid=inSANDP500(:,2);
ask=inSANDP500(:,3);
C=(bid+ask)./2;
r=inSANDP500(:,5);
S=7281.18;
w= 1./abs(bid-ask).^4;

eps=0.00000000000000000000000000001;
 i=0;
 fval1=10000;k=1;
 outK=outSANDP500(:,1);
outT=outSANDP500(:,4);
outbid=outSANDP500(:,2);
outask=outSANDP500(:,3);
outC=(outbid+outask)./2;
outr=outSANDP500(:,5);
options=optimset('MaxFunEvals',4000,'MaxIter',4000,'TolFun',1e-17,'TolX',1e-17);
 x0=[.4,.4,.10,0.1,-.1,1,1,1];
ub=[2 100 100 2 1 100 100 100];
lb=[0 0 0 0 -1 0 0 0];
%%
tic;
 [Theta, fval]=lsqnonlin(@(c) BCCDeltafft(c,C,S,K,T,r,w),x0,lb,ub,options);
toc;
%%
%Theta=[0.0209782870919362,10.2630531719262,0.0177892495204048,1.01209551130236,-0.583897890433693,0.00953852182762870,4.30875648765341e-08,2.02465822456147;];
v0=Theta(1);
kappa=Theta(2);
theta=Theta(3);
sigma=Theta(4);
rho=Theta(5);
l=Theta(6);
a=Theta(7);
g=Theta(8);
%%
display('_______________InSample_______________');
parfor i=1:length(C)
RAE(i)=abs(C(i)-BatesFFT(kappa,theta,sigma,rho,v0,l,a,g,r(i),0,T(i),S,K(i)))/C(i);
SE(i)=(C(i)-BatesFFT(kappa,theta,sigma,rho,v0,l,a,g,r(i),0,T(i),S,K(i)))^2;
end;
RMSE=sqrt(sum(SE)/length(C));
MRAE=mean(RAE)*100;
display(['Function Value  ',num2str(fval)]);
display(['Fitting Error (MRAE %) = ',num2str(MRAE),' %']);
display(['Fitting Error (RMSE = ',num2str(RMSE)]);
display(['Max Error %=',num2str(max(RAE)*100)]);

%%
display('____________OutOfSample__________________');
for i=1:length(outC)
outRAE(i)=abs(outC(i)-BatesFFT(kappa,theta,sigma,rho,v0,l,a,g,outr(i),0,outT(i),S,outK(i)))/outC(i);
outSE(i)=(C(i)-BatesFFT(kappa,theta,sigma,rho,v0,l,a,g,r(i),0,T(i),S,K(i)))^2;
end;
outRMSE=sqrt(sum(outSE)/length(outC));
MRAEout=mean(outRAE)*100;
 display(['Out of Sample Error (MRAE %) = ',num2str(MRAEout),' %']);
 display(['Fitting Error (RMSE = ',num2str(outRMSE)]);
 display(['Max Error %=',num2str(max(outRAE)*100)]);
I=2*kappa*theta-sigma^2;
display(['Theta = ' num2str(Theta)]);
if I>0
    display('Parameters are ok');
else
    error('Parameters are wrong');
end;