function obj=MLEndim(nVec,observationsY,observationsX,func,delta,t,T,vecSeas)
Sigma=diag(nVec(7:end));
risk=nVec(1:2);
vec=nVec(3:6);
[N,~]=size(observationsY);
obj=zeros(1,N);
lD=log(det(Sigma));
invSigma=inv(Sigma);
for i=0:N-1
    ti=t+delta*i;
    F=func(delta,ti,T,vec,vecSeas,observationsX(i+1),risk);
    obj(i+1)=lD+log((observationsY(i+1,:)-F)...
        *(invSigma)*(observationsY(i+1,:)-F)');
end;
obj=sum(obj);
