function V=sobolmat(cvec,minit,r)
%cvec has the form (1,c1,..,cq,1) minit length q<=r
q=length(cvec)-1;
if q==0 
    V=eye(r);
end;
pow2=2^(q:-1:1);
if q>0
    mvec=[minit(1:q) zeros(1,r-q)];
    mstate=minit;
    for i=q+1:q+r
        k=q;
        mnext=mstate(1);
        while  k>1
            mnext=xor(pow2(k)*cvec(q)*mstate(q-k+1),mnext);
            k=k-1;
        end;
        mvec(i)=mnext;
        mstate=[mstate(2:q),mnext];
    end;
    for j=1:r
        mbin=bary(mvec(j),2);
        k=length(mbin);
        for i=1:k
            V(j-i+1,j)=mbin(k-i+1);
        end;
    end;
end;