%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Executable Script.
% Author: Suren Islyaev
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clc;
clear;
%Load Data:
load gasoline.mat;
load HBnatgas.mat;
load lightoil.mat;
warning off all;

var_1=gasoline(1:end-1,:);
%mav=log((var_1(:,3:end-1)+var_1(:,2:end-2)+var_1(:,1:end-3))/3);
%var_1=var_1(2:end,:)-var_1(1:end-1,:);
mav=var_1;
[m,n]=size(mav);
detrend_var=zeros(m,n);
trend=zeros(m,n);
pval=zeros(1,n);
hval=zeros(1,n);
JBSTAT=zeros(1,n);
my_jb_stat=zeros(1,n);
CRITVAL=zeros(1,n);
for i=1:n
    detrend_var(:,i)=detrend(mav(:,i));
    trend(:,i)=mav(:,i)-detrend_var(:,i);
    [hval(i),pval(i),JBSTAT(i),CRITVAL(i)]=jbtest(detrend_var(:,i)',0.05);
    [my_jb_stat(i)]=my_jbtest(detrend_var(:,i)');
end
figure(1);
clf;
hold on;
plot(JBSTAT,'-.');
plot(CRITVAL,'r--');