function I=simpson(func,sj,beta,T,t,N) %%Composite simpson rule
h=(T-t)/2000;
lT=length(T);
dt=zeros(lT,N);
I=zeros(lT,1);
coeff=zeros(N,1);
coeff([1,N])=1;
coeff(2:2:N-1)=4;
coeff(3:2:N-2)=2;
parfor i=1:lT
    dt(i,:)=linspace(t,T(i),N);
end;

parfor i=1:lT
    I(i)=func(dt(i,:),sj,beta,T(i))*coeff*h(i)/3;
end;