function obj=MLEndim(nVec,observationsY,observationsX,func,delta,t,T,vec,vecSeas)
Sigma=diag(abs(nVec(4:3+length(T)))+0.01);
risk=nVec(1:3);
% if length(rVec)>3
%     vec=[vec rVec(4:5)];
% else
%      vec=[vec 0 0];
% end;
[N,~]=size(observationsY);
obj=zeros(1,N);
lD=log(det(Sigma));
invSigma=inv(Sigma);
 B=integral_jump([[vec(8),vec(9)],risk(3),vec(3)],T,0);

%% Calculate MLE
for i=0:N-1
    ti=t+delta*i;
    F=func(delta,ti,T,vec,vecSeas,observationsX(i+1),risk,B);
    obj(i+1)=lD+log((observationsY(i+1,:)-F)...
        *(invSigma)*(observationsY(i+1,:)-F)');
end;
obj=sum(obj);
