function [theta,fval]=match_moments(func,Nmoments,data,...
                                delta,theta,Lambda,options,method,variable)
M=zeros(1,Nmoments);
N=length(data);
for i=1:Nmoments;
    M(i)=sum(data.^i)/N;
end;

switch(method)
    case 'lsq'
    lu=theta(1,:);
    ld=theta(3,:);
    x0=theta(2,:);
    [theta,fval]=lsqnonlin(@(vec) minimizeMoments_lsq(M,...
                func,vec,Lambda,data(1),delta),x0,ld,lu,options);    
    case 'fmin'    
    x0=theta(2,:);
  
    [theta,fval]=fminsearch(@(variable) minimizeMoments(M,...
                func,vec,Lambda,data(1),delta),x0,options);
end;