%%
figure(1); clf;
title('Gasoline futures price one step ahead forecast MRAE');
TGasoline=round((GasolineNew(end,2:end)-300)./22);
Error=fGasolineError;
hold on;
a=plot(TGasoline,fGasolineError(2,:)*100,'o',...
    'MarkerEdgeColor','k');
b=plot(TGasoline,Error(3,:)*100,'*','MarkerEdgeColor','k');
c=plot(TGasoline,Error(4,:)*100,'^','MarkerEdgeColor','k');
d=plot(TGasoline,Error(5,:)*100,'p','MarkerEdgeColor','k');

ylabel('Error %');
xlabel('Time to Maturity (Months)');
legend([a,b,c,d],'OF','OFS','TF','TFS');
%%
figure(2); clf;
title('Natural Gas futures price one step ahead forecast MRAE');
Tnatgas=round((HB_Nat_Gas_new(end,2:end)-300)./22);
Error=fNatGasError;
hold on;
a=plot(Tnatgas,Error(2,:)*100,'o',...
    'MarkerEdgeColor','k');
b=plot(Tnatgas,Error(3,:)*100,'*','MarkerEdgeColor','k');
c=plot(Tnatgas,Error(4,:)*100,'^','MarkerEdgeColor','k');
d=plot(Tnatgas,Error(5,:)*100,'p','MarkerEdgeColor','k');
ylabel('Error %');
xlabel('Time to Maturity (Months)');
legend([a,b,c,d],'OF','OFS','TF','TFS');
%%
figure(3); clf;
title('Light Oil futures price one step ahead forecast MRAE')
Tlightoil=round((lightoil(end,2:end)-300)./22);
Error=fLightOilError;
hold on;
a=plot(Tlightoil,Error(2,:)*100,'o',...
    'MarkerEdgeColor','k');
b=plot(Tlightoil,Error(3,:)*100,'*','MarkerEdgeColor','k');
c=plot(Tlightoil,Error(4,:)*100,'^','MarkerEdgeColor','k');
d=plot(Tlightoil,Error(5,:)*100,'p','MarkerEdgeColor','k');
ylabel('Error %');
xlabel('Time to Maturity (Months)');
legend([a,b,c,d],'OF','OFS','TF','TFS');