function inmoney_outmoney(D,S,Theta,rf,delta,n,asset)
fK=D(:,1);
fT=D(:,3)*delta;
fbid=D(:,5);
fask=D(:,4);
fC=(fbid+fask)./2;
fr=rf;

g=length(fK);
fCn=zeros(1,g);
for i=1:g
    fCn(i)=mmpricer(Theta,fK(i),fT(i),S,fr(i));
end;
%%

% scatter3(fK,fT,abs(fC-fCn')./fC,'fill');

x=fK;
y=fT;
z=abs(fC-fCn')./fC;
tri = delaunay(x,y);

%% Plot it with TRISURF
subplot(3,3,n);
h = trisurf(tri, x, y, z);
axis vis3d
title([asset,' index price S=',num2str(S)]);
xlabel('K');
ylabel('T');
zlabel('MRAE');

