function [Delta, Gamma] =  Hedging(funchandle,S,n)
%funchandle - is a function we are going to use to find derivatives;
%S is an actual Stock value
%n-is ans absolute value of a stock change

Delta=(funchandle(S+n)-funchandle(S-n))/(2*n);
Gamma=(funchandle(S+n)-2*funchandle(S)+funchandle(S-n))/(n^2);

