clear;
clc;
load FTSE100.mat
[n,m]=size(FTSE100);
% index=(rand(n,1)<.25);
index=[false;true;false;false;false;false;false;false;true;true;true;false;false;false;false;false;false;false;false;false;false;false;true;false;false;false;false;false;false;false;true;false;false;false;false;false;false;false;false;false;false;false;false;false;false;false;false;false;false;false;true;false;false;true;true;false;false;false;false;false;false;false;true;false;false;false;false;false;true;true;true;false;false;false;false;true;true;false;false;true;true;false;false;false;false;false;true;false;false;true;false;false;true;false;true;false;];
%index=ones(1,n)*true;
inSANDP500=FTSE100(~index,:);
outSANDP500=FTSE100(index,:);
K=inSANDP500(:,1);
T=inSANDP500(:,4);
bid=inSANDP500(:,2);
ask=inSANDP500(:,3);
C=(bid+ask)./2;
r=inSANDP500(:,5);
S=5812.06;
options=optimset('MaxFunEvals',30000,'MaxIter',30000);
w= 1./abs(bid-ask).^2;

 %x0=[-1.77141980968246;0.521218477900870;0.576807274460822;-2.04251989508692;-0.364643895695628;-1.62419752202743;];
x0=[2.12309512707644;0.851642305599801;0.551338371215827;-0.687830668564957;0.345078521919249;];
%x0=randn([5 1]).*[4 1 1 1 1 ]';
 eps=0.00000000000000000000000000001;
 i=0;
 fval1=10000;k=1;
 outK=outSANDP500(:,1);
outT=outSANDP500(:,4);
outbid=outSANDP500(:,2);
outask=outSANDP500(:,3);
outC=(outbid+outask)./2;
outr=outSANDP500(:,5);
tic;
 while k>eps
 [Theta, fval]=fminsearch(@(c) minfunc(c,C,K,T,S,r,w),x0,options);
 k=abs(fval-fval1);
 fval1=fval; 
 i=i+1;
 end;
 toc;
MRAE=mean(abs(C-mmpricer(Theta,K,T,S,r))./C)*100;
maxERRORin=max(abs(C-mmpricer(Theta,K,T,S,r))./C)*100;
RMSEin=sqrt(sum((C-mmpricer(Theta,K,T,S,r)).^2)./length(C));

display('------------In-Sample--------------');
display(['Function Value  ',num2str(fval)]);
display(['Fitting Error (MRAE %) = ',num2str(MRAE),' %']);
display(['Fitting Error (RMSE) = ',num2str(RMSEin)]);
display(['Maximum Error = ',num2str(maxERRORin)]);
g=length(outK);
outCn=zeros(1,g);
for i=1:g
    outCn(i)=mmpricer(Theta,outK(i),outT(i),S,outr(i));
end;

MRAEout=mean(abs(outC-outCn')./outC)*100;
maxERRORout=max(abs(outC-outCn')./outC)*100;
MSE=sum((outC-outCn').^2)/length(outC);
RMSE=sqrt(MSE);
display('-----------Out-Of-Sample------------');
display(['Out of Sample Error (MRAE %) = ',num2str(MRAEout),' %']);
display(['Out of Sample Error (RMSE) = ',num2str(RMSE)])
display(['Put-Of-Sample Maximum Error = ',num2str(maxERRORout)]);
%plot(abs(outC-outCn')./outC);
%%
display('-----------Comparison------------');
CbsIn=bs(Theta,K,T,S,r);
norm2errorIn=sqrt(sum((CbsIn-mmpricer(Theta,K,T,S,r)).^2));
Cbs=bs(Theta,outK,outT,S,outr);
% figure(2);clf;
% plot(Cbs,'*');hold on;
% plot(outCn,'.');
% plot(outC,'r');
norm2error=sqrt(sum((Cbs-outCn').^2));
display(['Norm 2 Error  In-Sample = ',num2str(norm2errorIn)]);
display(['Norm 2 Error  Out of Sample = ',num2str(norm2error)]);

%% 
bsdelta=@(C,iv,K,T,S,R) (C-bs1(iv,K,T,S,R))^2;
Knew=linspace(min(K),max(K),10);
Tnew=linspace(min(T),max(T),50);



IV=zeros(length(Tnew),length(Knew));
Cnew=zeros(length(Tnew),length(Knew));
meanr=mean(r);

for i=1:length(Tnew)
    for j=1:length(Knew)
    Cnew(i,j)=mmpricer(Theta,Knew(j),Tnew(i),S,meanr);
    IV(i,j)=fminsearch(@(c) bsdelta(Cnew(i,j),c,Knew(j),Tnew(i),S,meanr),.3);
    end
end
figure(1);clf;
surf(Knew,Tnew,IV);
ylabel('Time To maturity');
xlabel('Strike Price');
zlabel('Volatility')
% figure(2);clf;
% surf(Knew,Tnew,Cnew);
% ylabel('Maturity');
% xlabel('Strike Price');
% zlabel('Option Price')
%%
% figure(3);clf;
% Tnew=linspace(min(T),max(T),200);
%  iv=impvolcalc(Theta,Tnew);
%  plot(iv);

 