function F=futprice(delta,t,T,vec,vecSeas,xt,risk)
%vec([1  3])=abs(vec([1  3]));
k=vec(1);
mu=vec(2);
sigma=vec(3);
%%Seasonality Parameters
alpha=vecSeas(1);
zeta=vecSeas(2);
phi=vecSeas(3);
psi=vecSeas(4);
tau=T;
%%Market Risk values
%risk=sin(risk);
h1=risk(1);
h2=risk(2);
%%Exponentials of tau kappa
exp1k=exp(-k*tau);
exp2k=exp(-2*k*tau);
%%Seasonality
S=alpha+zeta*sin(psi*(T+t)*delta+phi);
if length(xt)==2 
    h1=h1+xt(2);
end;
m1=exp1k*xt(1)+h1/k*(1-exp1k);
m2=exp(2*(mu+h2)+2*sigma^2)/k*.5*(1-exp2k);
Term1=3*(exp(4*sigma^2)-1)*exp(2*sigma^2+2*mu)/(48*k^2)*(1-exp2k);
Term2=15*(exp(8*sigma^2)-1)*exp(4*sigma^2+4*mu)/(4*720*k^2)*(1-exp2k).^2;
F=m1+log(m2/2)+log(1+Term1+Term2)+S;